unit ADOExamplesU1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    tblSuppliers: TTable;
    Button4: TButton;
    Button6: TButton;
    Button7: TButton;
    Memo2: TMemo;
    Label1: TLabel;
    edtCountry: TEdit;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    edtDSN: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  ADODB_TLB;

procedure TForm1.Button1Click(Sender: TObject);
var
  Conn: _Connection;
  RS: _RecordSet;
begin
  Conn:=CoConnection.Create;
  Conn.Open('DSN='+edtDSN.Text, '', '', -1);

  RS:=CoRecordSet.Create;

  RS.Open('Suppliers', Conn,
  adOpenForwardOnly, adLockReadOnly, adCmdTable);

  Memo1.Lines.Add(RS.Fields.Item[1].Value);

  RS.Close;
  Conn.Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Conn: _Connection;
begin
  Conn:=CoConnection.Create;
  Conn.Open('DSN='+edtDSN.Text, '', '', -1);

  Memo1.Lines.Add('ADO Version     : '+Conn.Version);
  Memo1.Lines.Add('DBMS Name       : '+Conn.Properties.Item['DBMS Name'].Value);
  Memo1.Lines.Add('DBMS Version    : '+Conn.Properties.Item['DBMS Version'].Value);
  Memo1.Lines.Add('OLE DB Version  : '+Conn.Properties.Item['OLE DB Version'].Value);
  Memo1.Lines.Add('Provider Name   : '+Conn.Properties.Item['Provider Name'].Value);
  Memo1.Lines.Add('Provider Version: '+Conn.Properties.Item['Provider Version'].Value);
  Memo1.Lines.Add('Driver Name     : '+Conn.Properties.Item['Driver Name'].Value);
  Memo1.Lines.Add('Driver Version  : '+Conn.Properties.Item['Driver Version'].Value);
  Memo1.Lines.Add('Driver ODBC Version: '+Conn.Properties.Item['Driver ODBC Version'].Value);


  Conn.Close;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Conn: _Connection;
  Command: _Command;
  RS: _RecordSet;
  RecordsAffected: OLEVariant;
begin
  Conn:=CoConnection.Create;
  Conn.Open('DSN='+edtDSN.Text, '', '', -1);

  Command:=CoCommand.Create;
  Command.Set_ActiveConnection(Conn);
  Command.CommandText:='SELECT * FROM Suppliers';
  Command.CommandType:=adCmdText;
  RS:=Command.Execute(RecordsAffected, EmptyParam, -1);

  while not RS.EOF do
  begin
    Memo1.Lines.Add(RS.Fields.Item[1].Value);
    RS.MoveNext;
  end;

  RS.Close;
  Conn.Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  Conn: _Connection;
  Command: _Command;
  RS: _RecordSet;
  RecordsAffected: OLEVariant;
  Parameter: _Parameter;
begin
  Conn:=CoConnection.Create;
  Conn.Open('DSN='+edtDSN.Text, '', '', -1);

  Command:=CoCommand.Create;
  Command.Set_ActiveConnection(Conn);

  Parameter:=
  Command.CreateParameter('PCOUNTRY', adBStr, adParamInput, Length(edtCountry.Text), edtCountry.Text);
  Command.Parameters.Append(Parameter);

  Command.CommandText:='SELECT * FROM Suppliers WHERE COUNTRY=?';
  Command.CommandType:=adCmdText;
  RS:=Command.Execute(RecordsAffected, EmptyParam, -1);

  while not RS.EOF do
  begin
    Memo1.Lines.Add(RS.Fields.Item[1].Value);
    RS.MoveNext;
  end;

  RS.Close;
  Conn.Close;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  Conn: _Connection;
  intProp: integer;
  Prop: Property_;
  strValue: WideString;
begin
  Conn:=CoConnection.Create;
  Conn.Open('DSN='+edtDSN.Text, '', '', -1);
  for intProp:=0 to Conn.Properties.Count - 1 do
  begin
    Prop:=Conn.Properties.Item[intProp];
    strValue:=Prop.Value;
      Memo1.Lines.Add(Prop.Name+' = '+strValue);
  end;

  Conn.Close;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  RS: _RecordSet;
begin
  RS:=CoRecordSet.Create;

  RS.Open('Suppliers',
  'Driver=Microsoft Access Driver (*.mdb);'+
  'DBQ=C:\Program Files\Microsoft Office\Office\Samples\Northwind.MDB',
  adOpenForwardOnly, adLockReadOnly, adCmdTable);

  Memo1.Lines.Add(RS.Fields.Item[1].Value);

  RS.Close;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  tblSuppliers.Active:=CheckBox1.Checked;
end;

end.
