unit AppMainFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MnuFile: TMenuItem;
    MnuLoadModule: TMenuItem;
    MnuExit: TMenuItem;
    PageControl: TPageControl;
    Sheet1: TTabSheet;
    BtnShowExtensibleForm: TButton;
    N1: TMenuItem;
    procedure MnuLoadModuleClick(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure BtnShowExtensibleFormClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses
  AppModuleLoadFormU, BaseFormU, AppSupportU;

{$R *.DFM}

procedure TMainForm.MnuLoadModuleClick(Sender: TObject);
begin
  ModuleLoadForm.ShowModal
end;

procedure TMainForm.MnuExitClick(Sender: TObject);
begin
  Application.Terminate
end;

procedure TMainForm.BtnShowExtensibleFormClick(Sender: TObject);
begin
  with BaseFormClass.Create(Application) do
    try
      ShowModal
    finally
      Free
    end
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  InitializePackageSupport;
  LoadPackagesStoredInRegistry
end;

procedure TMainForm.FormHide(Sender: TObject);
begin
  StorePackagesInRegistry;
  FinalizePackageSupport
end;

end.
