unit AppModuleLoadFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TModuleLoadForm = class(TForm)
    BtnOK: TButton;
    GroupBox1: TGroupBox;
    LstPackages: TListBox;
    BtnAddPackage: TButton;
    BtnRemovePackage: TButton;
    DlgOpenPackage: TOpenDialog;
    LblPackageFileName: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BtnAddPackageClick(Sender: TObject);
    procedure BtnRemovePackageClick(Sender: TObject);
    procedure LstPackagesClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ModuleLoadForm: TModuleLoadForm;

implementation

uses
  AppSupportU, FileCtrl;

{$R *.DFM}

procedure TModuleLoadForm.FormCreate(Sender: TObject);
{$ifdef Ver100} //Delphi 3 - packages have DPL extension
var
  S: String;
  I: Integer;
begin
  S := DlgOpenPackage.Filter;
  repeat
    I := Pos('bpl', S);
    if I > 0 then
      S[I] := 'd' //Change the "bpl" to "dpl"
  until I = 0;
  DlgOpenPackage.Filter := S;
{$else}
begin
{$endif}
end;

procedure TModuleLoadForm.FormShow(Sender: TObject);
begin
  FormatPackagesAsDisplayList(LstPackages.Items)
end;

procedure TModuleLoadForm.BtnAddPackageClick(Sender: TObject);
begin
  if DlgOpenPackage.Execute then
  begin
    LoadCustomPackage(DlgOpenPackage.FileName);
    FormatPackagesAsDisplayList(LstPackages.Items)
  end
end;

procedure TModuleLoadForm.BtnRemovePackageClick(Sender: TObject);
begin
  if LstPackages.ItemIndex <> -1 then
  begin
    UnloadCustomPackage(HModule(LstPackages.Items.Objects[LstPackages.ItemIndex]));
    FormatPackagesAsDisplayList(LstPackages.Items)
  end
end;

procedure TModuleLoadForm.LstPackagesClick(Sender: TObject);
begin
  //FileCtrl.MinimizeName inserts dots to shorten
  //a long path name for display purposes
  LblPackageFileName.Caption := MinimizeName(
    TPackageRec(PackageList[LstPackages.ItemIndex]^).FileName,
    Canvas, LstPackages.Width)
end;

end.
 